/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./lib/Array.js":
/*!**********************!*\
  !*** ./lib/Array.js ***!
  \**********************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
Object.defineProperties(Array.prototype, {
    first: {
        get: function () {
            if (this.length > 0)
                return this[0];
            else
                return undefined;
        }
    },
    last: {
        get: function () {
            if (this.length > 0)
                return this[this.length - 1];
            else
                return undefined;
        }
    },
    isEmpty: {
        get: function () {
            return this.length < 1;
        }
    },
    randomElement: {
        get: function () {
            var _this = this;
            return function () {
                if (_this.isEmpty)
                    return undefined;
                var index = Math.floor(Math.random() * _this.length);
                return _this[index];
            };
        }
    },
    insert: {
        get: function () {
            var _this = this;
            return function (element, at) {
                _this.splice(at, 0, element);
            };
        }
    },
    remove: {
        get: function () {
            var _this = this;
            return function (at) {
                _this.splice(at, 1);
            };
        }
    },
    compactMap: {
        get: function () {
            var _this = this;
            return function (callback) {
                var results = [];
                for (var i = 0; i < _this.length; i++) {
                    var result = callback(_this[i], i, _this);
                    if (result !== undefined && result !== null)
                        results.push(result);
                }
                return results;
            };
        }
    },
    shuffled: {
        get: function () {
            var _this = this;
            return function () {
                var clone = _this.slice();
                clone.shuffle();
                return clone;
            };
        }
    },
    shuffle: {
        get: function () {
            var _this = this;
            return function () {
                var _a;
                for (var i = (_a = _this.endIndex) !== null && _a !== void 0 ? _a : -1; i > 0; i--) {
                    var j = Math.floor(Math.random() * (i + 1));
                    var tmp = _this[i];
                    _this[i] = _this[j];
                    _this[j] = tmp;
                }
            };
        }
    },
    swapAt: {
        get: function () {
            var _this = this;
            return function (indexA, indexB) {
                var temp = _this[indexB];
                _this[indexB] = _this[indexA];
                _this[indexA] = temp;
            };
        }
    },
    startIndex: {
        get: function () {
            var indices = Object.keys(this);
            if (indices.isEmpty || typeof indices.first !== 'string')
                return undefined;
            var startIndex = parseInt(indices.first);
            if (isNaN(startIndex))
                return undefined;
            else
                return startIndex;
        }
    },
    endIndex: {
        get: function () {
            var indices = Object.keys(this);
            if (indices.isEmpty || typeof indices.last !== 'string')
                return undefined;
            var endIndex = parseInt(indices.last);
            if (isNaN(endIndex))
                return undefined;
            else
                return endIndex;
        }
    }
});
//# sourceMappingURL=Array.js.map

/***/ }),

/***/ "./lib/Boolean.js":
/*!************************!*\
  !*** ./lib/Boolean.js ***!
  \************************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
Object.defineProperties(Boolean, {
    random: {
        get: function () {
            return function () { return Math.random() > 0.5; };
        }
    }
});
//# sourceMappingURL=Boolean.js.map

/***/ }),

/***/ "./lib/Number.js":
/*!***********************!*\
  !*** ./lib/Number.js ***!
  \***********************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
Object.defineProperties(Number, {
    zero: {
        get: function () {
            return 0;
        }
    }
});
Object.defineProperties(Number.prototype, {
    quotientAndRemainderOf: {
        get: function () {
            var _this = this;
            return function (dividingBy) {
                var n = _this.valueOf();
                var divisionResult = n / dividingBy;
                var quotient = Math.floor(divisionResult);
                var remainder = n - (quotient * dividingBy);
                return [quotient, remainder];
            };
        }
    },
    isMultipleOf: {
        get: function () {
            var _this = this;
            return function (of) {
                var n = _this.valueOf();
                return (n % of === 0);
            };
        }
    },
    isZero: {
        get: function () {
            return this.valueOf() === 0;
        }
    }
});
//# sourceMappingURL=Number.js.map

/***/ }),

/***/ "./lib/Object.js":
/*!***********************!*\
  !*** ./lib/Object.js ***!
  \***********************/
/***/ (function(__unused_webpack_module, exports) {


var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
Object.defineProperties(Object.prototype, {
    isEmpty: {
        get: function () {
            return Object.keys(this).length === 0;
        }
    },
    count: {
        get: function () {
            return Object.keys(this).length;
        }
    },
    first: {
        get: function () {
            return Object.values(this)[0];
        }
    },
    randomElement: {
        get: function () {
            var _this = this;
            return function () {
                var index = Math.floor(Math.random() * Object.values(_this).length);
                return Object.values(_this)[index];
            };
        }
    },
    merge: {
        get: function () {
            var _this = this;
            return function (objectToMerge, uniquingKeysWith) {
                Object.keys(objectToMerge).forEach(function (key) {
                    if (_this.hasOwnProperty(key))
                        _this[key] = uniquingKeysWith(_this[key], objectToMerge[key]);
                    else
                        _this[key] = objectToMerge[key];
                });
            };
        }
    },
    merging: {
        get: function () {
            var _this = this;
            return function (objectToMerge, uniquingKeysWith) {
                var merged = __assign({}, _this);
                merged.merge(objectToMerge, uniquingKeysWith);
                return merged;
            };
        }
    },
    removeValue: {
        get: function () {
            var _this = this;
            return function (forKey) {
                delete _this[forKey];
            };
        }
    },
    removeAll: {
        get: function () {
            var _this = this;
            return function () {
                Object.keys(_this).forEach(function (key) { return delete _this[key]; });
            };
        }
    },
    contains: {
        get: function () {
            var _this = this;
            return function (where) {
                for (var key in _this) {
                    if (where(key, _this[key]))
                        return true;
                }
                return false;
            };
        }
    },
    allSatisfy: {
        get: function () {
            var _this = this;
            return function (callback) {
                for (var key in _this) {
                    if (!callback(key, _this[key]))
                        return false;
                }
                return true;
            };
        }
    }
});
//# sourceMappingURL=Object.js.map

/***/ }),

/***/ "./lib/String.js":
/*!***********************!*\
  !*** ./lib/String.js ***!
  \***********************/
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
Object.defineProperties(String.prototype, {
    isEmpty: {
        get: function () {
            return this.valueOf().length === 0;
        }
    },
    inserted: {
        get: function () {
            var _this = this;
            return function (substring, at) {
                return _this.slice(0, at) + substring + _this.slice(at);
            };
        }
    },
    first: {
        get: function () {
            if (this.length > 0)
                return this[0];
            else
                return undefined;
        }
    },
    last: {
        get: function () {
            if (this.length > 0)
                return this[this.length - 1];
            else
                return undefined;
        }
    },
    randomElement: {
        get: function () {
            var _this = this;
            return function () {
                if (_this.length < 1)
                    return undefined;
                var index = Math.floor(Math.random() * _this.length);
                return _this[index];
            };
        }
    },
    map: {
        get: function () {
            var _this = this;
            return function (callback) {
                var mappedString = '';
                for (var i = 0; i < _this.length; i++) {
                    mappedString += callback(_this[i], i, _this.valueOf());
                }
                return mappedString;
            };
        }
    },
    compactMap: {
        get: function () {
            var _this = this;
            return function (callback) {
                var mappedString = '';
                for (var i = 0; i < _this.length; i++) {
                    var mappedChar = callback(_this[i], i, _this.valueOf());
                    if (typeof mappedChar === 'string')
                        mappedString += mappedChar;
                }
                return mappedString;
            };
        }
    },
    forEach: {
        get: function () {
            var _this = this;
            return function (callback) {
                for (var i = 0; i < _this.length; i++) {
                    callback(_this[i], i, _this.valueOf());
                }
            };
        }
    },
    reduce: {
        get: function () {
            var _this = this;
            return function (callback, initialValue) {
                var val = initialValue;
                for (var i = 0; i < _this.length; i++) {
                    val = callback(val, _this[i], i);
                }
                return val;
            };
        }
    },
    startIndex: {
        get: function () {
            if (this.length > 0)
                return 0;
            else
                return undefined;
        }
    },
    endIndex: {
        get: function () {
            if (this.length > 0)
                return this.length - 1;
            else
                return undefined;
        }
    },
    sorted: {
        get: function () {
            var _this = this;
            return function () {
                return _this.split('').sort().join('');
            };
        }
    },
    reversed: {
        get: function () {
            var _this = this;
            return function () {
                var _a;
                var reversed = '';
                for (var i = (_a = _this.endIndex) !== null && _a !== void 0 ? _a : -1; i >= 0; i--) {
                    reversed += _this[i];
                }
                return reversed;
            };
        }
    },
    shuffled: {
        get: function () {
            var _this = this;
            return function () {
                return _this.split('').shuffled().join('');
            };
        }
    },
    prefix: {
        get: function () {
            var _this = this;
            return function (callback) {
                var prefix = '';
                for (var i = 0; i < _this.length; i++) {
                    var charPassesCallback = callback(_this[i], i, _this.valueOf());
                    if (charPassesCallback)
                        prefix += _this[i];
                    else
                        break;
                }
                return prefix;
            };
        }
    }
});
//# sourceMappingURL=String.js.map

/***/ }),

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__exportStar(__webpack_require__(/*! ./Array */ "./lib/Array.js"), exports);
__exportStar(__webpack_require__(/*! ./Number */ "./lib/Number.js"), exports);
__exportStar(__webpack_require__(/*! ./String */ "./lib/String.js"), exports);
__exportStar(__webpack_require__(/*! ./Object */ "./lib/Object.js"), exports);
__exportStar(__webpack_require__(/*! ./Boolean */ "./lib/Boolean.js"), exports);
//# sourceMappingURL=index.js.map

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./lib/index.js");
/******/ 	
/******/ })()
;
//# sourceMappingURL=typeswift.js.map