"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
Object.defineProperties(Object.prototype, {
    isEmpty: {
        get: function () {
            return Object.keys(this).length === 0;
        }
    },
    count: {
        get: function () {
            return Object.keys(this).length;
        }
    },
    first: {
        get: function () {
            return Object.values(this)[0];
        }
    },
    randomElement: {
        get: function () {
            var _this = this;
            return function () {
                var index = Math.floor(Math.random() * Object.values(_this).length);
                return Object.values(_this)[index];
            };
        }
    },
    merge: {
        get: function () {
            var _this = this;
            return function (objectToMerge, uniquingKeysWith) {
                Object.keys(objectToMerge).forEach(function (key) {
                    if (_this.hasOwnProperty(key))
                        _this[key] = uniquingKeysWith(_this[key], objectToMerge[key]);
                    else
                        _this[key] = objectToMerge[key];
                });
            };
        }
    },
    merging: {
        get: function () {
            var _this = this;
            return function (objectToMerge, uniquingKeysWith) {
                var merged = __assign({}, _this);
                merged.merge(objectToMerge, uniquingKeysWith);
                return merged;
            };
        }
    },
    removeValue: {
        get: function () {
            var _this = this;
            return function (forKey) {
                delete _this[forKey];
            };
        }
    },
    removeAll: {
        get: function () {
            var _this = this;
            return function () {
                Object.keys(_this).forEach(function (key) { return delete _this[key]; });
            };
        }
    },
    contains: {
        get: function () {
            var _this = this;
            return function (where) {
                for (var key in _this) {
                    if (where(key, _this[key]))
                        return true;
                }
                return false;
            };
        }
    },
    allSatisfy: {
        get: function () {
            var _this = this;
            return function (callback) {
                for (var key in _this) {
                    if (!callback(key, _this[key]))
                        return false;
                }
                return true;
            };
        }
    }
});
//# sourceMappingURL=Object.js.map